.\" Toby Jaffey 1999
.\"
.TH DRAWTOOL 1 "April 11th 1998" DrawTool DrawTool
.SH NAME
drawtool \- vector based drawing in gtk
.SH SYNOPSIS
.BR drawtool " [" -g , " --geometry"
.IR WWxHH+XX+YY ]
.RB [ -o , " --outfile"
.IR filename ]
.RB [ -i , " --infile"
.IR filename ]
.RB [ -r , " --rcfile"
.IR rcfilename ]

.B drawtool
.BR -h , " --help"
.br
.B drawtool
.BR -t , " --throughput"
.br
.B drawtool
.BR -b , " --nobuttons"

.SH SYNOPSIS
.B drawtool
Drawtool is a simple application that reads in simple vector geometry from
stdin and displays it in a gtk window. Similarly, it will write data onto
stdout as generated by click-drag mouse movements.

.SH DESCRIPTION
Drawtool takes newline separated, lines of vector data in a proprietary
.BR format
from stdin by default. It will output data corresponding to the actions of
the user in an identical
.BR format
to stdout.
.BR Macros
can be added in order to extend the program.

.SH OPTIONS
.TP
.BI "-h, --help "
Show the help screen 
.TP
.BI "-t, --throughput "
Pipe all incoming data to the output stream.
.TP
.BI "-g, --geometry"
.BR WWxHH+XX+YY
Specify the initial window position in terms of
.BR Width
.BR Height
.BR XCoordinate
.BR YCoordinate
.TP
.BI "-b, --nobuttons"
Omit the buttons from the main window
.TP
.BI "-o, --outfile"
.BR filename
Use a file for output rather than stdout.
.TP
.BI "-i, --infile"
.BR filename
Use a file for input rather than stdin.
.TP
.BI "-r, --rcfile"
.BR filename
Use filename as the config file, rather than the default ~/.drawtoolrc

.SH MACROS

.B drawtool
can take advantage of external scripts and binaries that generate data.
Macros are called with seven command line arguments,
.BI "x1 y1 x2 y2 r g b"
where
.BI "(x1,y1),(x2,y2) "
specifies the bounding box selected by the user, and 
.BI "(r,g,b) "
are three integers representing the red, green and blue components of the
current user selected colour. If the script is deemed as type 1, then it
will be passed all 7 parameters, but
.BI "x2,y2 "
cannot be relied on (this is for operations that only require one spot).
Type 2 scripts will be passed the full 7, meaning that they are able to
determine the bounding box selected by the user.

.SH DATA FORMAT
where:
.BI "(x1,y2) "
or
.BI "(x2,y2) "
are integer coordinates and
.BI "(r,g,b) "
are integer red, green and blue colour values.
.TP
.BI point
0,x1,y1,r,g,b
.TP
.BI line
1,x1,y1,x2,y2,r,g,b	
.TP
.BI "empty rectangle"
2,x1,y1,x2,y2,r,g,b
.TP
.BI "filled rectangle"
3,x1,y1,x2,y2,r,g,b
.TP
.BI "empty circle"
4,x1,y1,radius,r,g,b
.TP
.BI "filled circle"
5,x1,y1,radius,r,g,b
.TP
.BI "empty ellipse"
6,x1,y1,x2,y2,r,g,b
.TP
.BI "filled ellipse"
7,x1,y1,x2,y2,r,g,b

.SH "SEE ALSO (for scripting)"
.IR "sh, perl, awk, bc"

.SH BUGS
.B tags
Too slow, too ugly, totally unreadable source, too memory hungry, it uses X.

If it crashes on you, please compile it with the -g flag and send me a core
file (if there is one). Also, if you want the problem fixed, I need to be
able to reproduce it, so please be clear.

.SH AUTHOR
Toby Jaffey <psystrj@granby.nottingham.ac.uk>

Please mail me with your experiences of using
.B drawtool
especially if you have extended it in some way, either through hacking the
source, or preferably by writing nifty macros that do amazing things.
