#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <getopt.h>

char *macroName;

int cmdline(int argc,char *argv[],int *x,int *y,int *x2,int *y2,int *maxhatch,int *err)
{
struct stat st;
int c=0;
int option_index = 0;
int a=0;
static struct option long_options[] = 
	{
		{"help",0,0,'h'},
		{"commands",0,0,'c'},
		{"turtles",1,0,'t'},
		{"xpos",1,0,'x'},
		{"ypos",1,0,'y'},
		{"tox",1,0,'v'}, // v and w lead to' x and y?
		{"toy",1,0,'w'}, // you think of a better name :-P
		{"macro",1,0,'m'},
		{"errors",0,0,'e'},
		{0,0,0,0}
	};

while (c!=EOF)
{
c = getopt_long(argc,argv,"hm:ct:x:y:v:w:e",long_options,&option_index);

switch(c)
	{
	case 0:
	fprintf(stderr,"option %s",long_options[option_index].name);
	if (optarg)
	fprintf(stderr," with arg %d",(int)optarg);
	fprintf(stderr,"\n");
	break;

	case 'h':
	fprintf(stderr,"Logo -- Copyright Toby Jaffey 1999");
	fprintf(stderr,"\nBug reports to psystrj@nottingham.ac.uk");
	fprintf(stderr,"\n\nUsage: logo");
	fprintf(stderr,"\noptions:");
	fprintf(stderr,"\n-h\t\t\t--help\tthis help");
	fprintf(stderr,"\n-c\t\t\t--commands\tlist commands");
	fprintf(stderr,"\n-t\t\t\t--turtles\tmaximum turtles to be hatched");
	fprintf(stderr,"\n-x\t\t\t--xpos\tstarting x coordinate");
	fprintf(stderr,"\n-y\t\t\t--ypos\tstarting y coordinate");
	fprintf(stderr,"\n-v\t\t\t--tox\tpoint to x coordinate");
	fprintf(stderr,"\n-w\t\t\t--toy\tpoint to y coordinate");
	fprintf(stderr,"\n-m\t\t\t--macro\tuse macro for output");
	fprintf(stderr,"\n\n");
	exit(-1);
	break;

	case 'c':
	fprintf(stderr,"Commands --");	
	fprintf(stderr,"\nFD x\t\t- Move ForwarD x points");
	fprintf(stderr,"\nBK x\t\t- Move BacKward x points");
	fprintf(stderr,"\nLT x\t\t- Left Turn x degrees");
	fprintf(stderr,"\nRT x\t\t- Right Turn x degrees");
	fprintf(stderr,"\nHT\t\t- Hatch Turtle");
	fprintf(stderr,"\nKT\t\t- Kill Turtle");
	fprintf(stderr,"\nPU\t\t- Pen Up off the pad");
	fprintf(stderr,"\nPD\t\t- Pen Down onto the pad");
	fprintf(stderr,"\nPC r,g,b\t- Pen Colour r,g,b (where 0 < [rgb] < 65536)");
	fprintf(stderr,"\n\n");
	exit(-1);
	break;
	
	case 't':
	if (sscanf(optarg,"%d",maxhatch) < 1 )
		{
		fprintf(stderr,"\nInvalid turtle number (%s)\n",optarg);
		exit(-1);
		}
	break;

	case 'm':
	if ( (macroName = malloc(255))==NULL) exit(-1);
	else // why do I always find these elses funny?
	if (sscanf(optarg,"%s",macroName) < 1 )
		{
		fprintf(stderr,"\nInvalid macroname (%s)\n",optarg);
		exit(-1);
		}
	else
		{
		if (lstat(macroName,&st) <0 )
			{
			fprintf(stderr,"\nbad file %s\n\n",macroName);
			exit(-4);
			}
		if ( !(st.st_mode & S_IEXEC ) )
			{
			fprintf(stderr,"\n%s not executable file\n\n",macroName);
			exit(-5);
			}
		}
	break;

	case 'x':
	if (sscanf(optarg,"%d",x) < 1 )
		{
		fprintf(stderr,"\nInvalid x (%s)\n",optarg);
		exit(-1);
		}
	break;
	
	case 'v':
	if (sscanf(optarg,"%d",x2) < 1 )
		{
		fprintf(stderr,"\nInvalid to x (%s)\n",optarg);
		exit(-1);
		}
	a++;
	break;
	
	case 'w':
	if (sscanf(optarg,"%d",y2) < 1 )
		{
		fprintf(stderr,"\nInvalid to y (%s)\n",optarg);
		exit(-1);
		}
	a++;
	break;
	
	case 'y':
	if (sscanf(optarg,"%d",y) < 1 )
		{
		fprintf(stderr,"\nInvalid y (%s)\n",optarg);
		exit(-1);
		}
	break;
	
	case 'e':
	*err=1;
	break;
	
	case 63: // ARGGGGGGGGGHHHHHHHHHHHHhh WHY GOD WHY???
	exit(-2);
	break;
	} // end switch c
} // end while
if (a==1)
	{
	fprintf(stderr,"\nBoth --tox and --toy args are needed\n\n");
	exit(-1);
	}
return a; // 0 for to tox,toy, 2 for orientation needed
} // end parse command line params
