#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdlib.h>
#include "turtle.h"

extern int penDown;
extern int colourR;
extern int colourG;
extern int colourB;
extern int xHome;
extern int yHome;
extern int Angle;
extern char *macroName;

void home(turtle *foo)
{
foo->x = xHome;
foo->y = yHome; // start in the middle
foo->angle = Angle;
} // end go home


void copyTurtle(turtle *dest,turtle *src)
{
dest->x = src->x;
dest->y = src->y;
dest->angle = src->angle;
} // end copy


void forward(turtle *foo,short d)
{
float t;
float x,y;

x = foo->x;
y = foo->y;

t = cos(DegToRad(foo->angle)) * d;
foo->x += t;

t = sin(DegToRad(foo->angle)) * d;
foo->y += t;

drawLine((short)x,(short)y,(short)foo->x,(short)foo->y);
} // end forward


void back(turtle *foo,short d)
{
turnLeft(foo,180);
forward(foo,d);
turnLeft(foo,180);
} // end back


void turnLeft(turtle *foo,short a)
{
foo->angle -= a;

if (foo->angle >= 360)  foo->angle-=360;
if (foo->angle <= -360) foo->angle+=360;

} // end turn


void turnRight(turtle *foo,short a)
{
foo->angle += a;

if (foo->angle >= 360)  foo->angle-=360;
if (foo->angle <= -360) foo->angle+=360;

} // end turn

void drawLine(short x1,short y1,short x2,short y2)
{
char *str=NULL;
FILE *fp=NULL;
char *r;

if (penDown)
	{
	if (macroName==NULL)
		{
		printf("1,%d,%d,%d,%d,%d,%d,%d\n",x1,y1,x2,y2,colourR,colourG,colourB);
		fflush(stdout);
		}
	else
		{
		if ((str=malloc(255))==NULL) exit(-1);
		sprintf(str,"%s %d %d %d %d %d %d %d",macroName,x1,y1,x2,y2,colourR,colourG,colourB);
		fp=popen(str,"r");
		if (fp==NULL)
			{
			fprintf(stderr,"\nCan't open pipe to %s",macroName);
			exit(-2);
			} // implied else...
		while (!feof(fp))
			{
			r = fgets(str,255,fp);
			if (r!=NULL)
				{
				fputs(str,stdout);
				fflush(stdout);
				}
			}
		pclose(fp);
		free(str);
		}
	}
} // end draw line