#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// Macros to plot primitives
#define plot(x,y,r,g,b) printf("0,%d,%d,%d,%d,%d\n",x,y,r,g,b)
#define line(x1,y1,x2,y2,r,g,b) printf("1,%d,%d,%d,%d,%d,%d,%d\n",x1,y1,x2,y2,r,g,b)
#define rect(x1,y1,x2,y2,r,g,b) printf("2,%d,%d,%d,%d,%d,%d,%d\n",x1,y1,x2,y2,r,g,b)
#define fillrect(x1,y1,x2,y2,r,g,b) printf("3,%d,%d,%d,%d,%d,%d,%d\n",x1,y1,x2,y2,r,g,b)
#define circle(x1,y1,rad,r,g,b) printf("4,%d,%d,%d,%d,%d,%d\n",x1,y1,rad,r,g,b)
#define fillcircle(x1,y1,rad,r,g,b) printf("5,%d,%d,%d,%d,%d,%d\n",x1,y1,rad,r,g,b)
#define ellipse(x1,y1,x2,y2,r,g,b) printf("6,%d,%d,%d,%d,%d,%d,%d\n",x1,y1,x2,y2,r,g,b)
#define fillellipse(x1,y1,x2,y2,r,g,b) printf("7,%d,%d,%d,%d,%d,%d,%d\n",x1,y1,x2,y2,r,g,b)

#define sgn(x) ((x<0)?-1:((x>0)?1:0)) /* macro to return the sign of a
                                         number */


void doAction(int x1,int y1,int x2,int y2,int r,int g,int b);
int min(int a,int b);
int max(int a,int b);

int main(int argc,char *argv[])
{
int x1,x2,y1,y2,r,g,b;

if (argc!=8)
	{
	fprintf(stderr,"\nWrong number of args\n\n");
	exit(-1);
	}

x1 = atoi(argv[1]);
y1 = atoi(argv[2]);
x2 = atoi(argv[3]);
y2 = atoi(argv[4]);
r  = atoi(argv[5]);
g  = atoi(argv[6]);
b  = atoi(argv[7]);

doAction(x1,y1,x2,y2,r,g,b);

return 1;
} // end main

int max(int a,int b)
{
if (a>b) return a;
else return b;
}

int min(int a,int b)
{
if (a<b) return a;
else return b;
}

void doAction(int x1,int y1,int x2,int y2,int r,int g,int b)
{
int i,dx,dy,sdx,sdy,dxabs,dyabs,x,y,px,py;

dx = x2-x1;      // the horizontal distance of the line
dy = y2-y1;      // the vertical distance of the line
dxabs = abs(dx);
dyabs = abs(dy);
sdx = sgn(dx);
sdy = sgn(dy);
x = dyabs>>1;
y = dxabs>>1;
px = x1;
py = y1;

if (dxabs>=dyabs) // the line is more horizontal than vertical
	{
	for(i=0;i<dxabs;i++)
		{
		y+=dyabs;
		if (y>=dxabs)
			{
			y-=dxabs;
			py+=sdy;
			}
		px+=sdx;
		//plot(px,py,r,g,b);
		fillcircle(px,py,2,r,g,b);
		}
	}
else // the line is more vertical than horizontal
	{
	for(i=0;i<dyabs;i++)
		{
		x+=dxabs;
		if (x>=dyabs)
			{
			x-=dyabs;
			px+=sdx;
			}
		py+=sdy;
		//plot(px,py,r,g,b);
		fillcircle(px,py,2,r,g,b);
		}
	}
} // end do something
