#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "getopt.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "drawtool.h"


int throughput=0;

char *cmdline(int argc,char *argv[],int *xsize,int *ysize,int *xoff,int *yoff,int *showButtons,int *inFile, int *outFile,int *dieOnEOF)
{
int c=0;
int in,out;
int option_index = 0;
char *name;
char *rcfile;
char *home;

static struct option long_options[] = 
	{
		{"help",0,0,'h'},
		{"geometry",1,0,'g'},
		{"infile",1,0,'i'},
		{"outfile",1,0,'o'},
		{"throughput",0,0,'t'},
		{"nobuttons",0,0,'b'},
		{"dieoneof",0,0,'d'},
		{"rcfile",1,0,'r'},
		{0,0,0,0}
	};

if ((name = malloc(255))==NULL) exit(-1);
if ( (home = getenv("HOME")) == NULL )
	{
	fprintf(stderr,"\nNo $HOME environment variable\n\n");
	exit(5);
	}
else // :-)
rcfile = strcat(home,"/");
rcfile = strcat(rcfile,RCFILE);


while (c!=EOF)
{
c = getopt_long(argc,argv,"hg:i:o:tbdr:",long_options,&option_index);

switch(c)
	{
	case 0:
	fprintf(stderr,"option %s",long_options[option_index].name);
	if (optarg)
	fprintf(stderr," with arg %d",(int)optarg);
	fprintf(stderr,"\n");
	break;

	case 'b':
	*showButtons = 0;
	break;

	case 'h':
	fprintf(stderr,"DrawTool v0.1b -- Copyright Toby Jaffey 1999");
	fprintf(stderr,"\nBug reports to psystrj@nottingham.ac.uk");
	fprintf(stderr,"\n\nUsage: drawtool");
	fprintf(stderr,"\noptions:");	
	fprintf(stderr,"\n-h\t\t\t--help\tthis help");
	fprintf(stderr,"\n-t\t\t\t--throughput\tact like a window on a pipe");
	fprintf(stderr,"\n-g WWxHH+XX+YY\t\t--geometry\tset X geometry");
	fprintf(stderr,"\n-b\t\t\t--nobuttons\tdon't display any buttons in window");
	fprintf(stderr,"\n-i file\t\t\t--infile\ttake input from file");
	fprintf(stderr,"\n-o file\t\t\t--outfile\twrite output to file");
	fprintf(stderr,"\n-d\t\t\t--dieoneof\texit program on eof in input");
	fprintf(stderr,"\n-r file\t\t\t--rcfile\tuse file as rc file");
	fprintf(stderr,"\n\n");
	exit(-1);
	break;
	
	case 't':
	throughput = 1;
	break;
	
	case 'd':
	*dieOnEOF = 1;
	break;
	
	case 'g':
	if (sscanf(optarg,"%dx%d+%d+%d",xsize,ysize,xoff,yoff) <4 )
		{
		fprintf(stderr,"\nInvalid geometry string (%s)\n",optarg);
		exit(-1);
		}
	break;
	
	case 'r':
	rcfile = g_strdup(optarg);
	break;
	
	
	case 'i':
	in = open(optarg,O_RDONLY);
	if (in!=-1) *inFile = in;
	else
		{
		fprintf(stderr,"\nInvalid filename %s\n",optarg);
		exit(-1);
		}
	break;
	
	case 'o':
	out = creat(optarg,(0666 & 0777)); // what's wrong with this?
	if (out!=-1) *outFile = out;
	else
		{
		fprintf(stderr,"\nInvalid filename %s\n",optarg);
		exit(-1);
		}
	break;
	
	case 63: // ARGGGGGGGGGHHHHHHHHHHHHhh WHY GOD WHY???
	exit(-2);
	break;
	} // end switch c
} // end while
return rcfile;
} // end parse command line params
