// drawtool.c
// Copyright March 28th 1999 Toby Jaffey.

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include "drawtool.h"

gint tag;
GtkWidget *indicator;
FILE *output,*input;
int dieOnEOF=0;
GtkWidget *darea;
macro **macros;
int showButtons = 1;


int main(int argc, char *argv[])
{
GtkWidget *window,*vbox,*hbox1,*hbox2,*hbox3,*hbox4,*hbox5,*hbox6,*drawing_area,*menu;
int xsize=256,ysize=256,xoff=100,yoff=100; // default geometry
int inFile=0,outFile=1; // default stdin,stdout
int num;
char *rcfile;

if ((macros = (macro **)malloc((sizeof(macro *))*100)) == NULL) exit(-1);

gtk_init(&argc, &argv);
rcfile = cmdline(argc,argv,&xsize,&ysize,&xoff,&yoff,&showButtons,&inFile,&outFile,&dieOnEOF);

if ((output = fdopen(outFile,"w") ) == NULL ) exit(-1);

window = createDrawWindow(xsize,ysize,xoff,yoff);
vbox = createVBox(window);
darea = drawing_area = createDrawArea(window,vbox,xsize,ysize);

if (showButtons)
	{
	hbox1 = createHBox(vbox);
	hbox2 = createHBox(vbox);
	hbox3 = createHBox(vbox);
	hbox4 = createHBox(vbox);
	hbox5 = createHBox(vbox);
	hbox6 = createHBox(vbox);
	addButton(hbox1,window,"Point",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)POINT);
	addButton(hbox1,window,"Line",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)LINE);
	addButton(hbox2,window,"Empty Rect",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)EMPTYRECT);
	addButton(hbox2,window,"Filled Rect",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)FILLRECT);
	addButton(hbox3,window,"Empty Circle",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)EMPTCIRCLE);
	addButton(hbox3,window,"Filled Circle",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)FILLCIRCLE);
	addButton(hbox4,window,"Empty Ellipse",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)EMPTELLIPSE);
	addButton(hbox4,window,"Filled Ellipse",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)FILLELLIPSE);
	addButton(hbox5,window,"Colour Picker",1,GTK_SIGNAL_FUNC(createEasyColourWindow),(gpointer)window);
	addButton(hbox5,window,"Eyedropper",1,GTK_SIGNAL_FUNC(handle_buttons),(gpointer)EYEDROPPER);
	indicator = addDrawBox(hbox5,window,10,10,GTK_SIGNAL_FUNC(draw_indicator),(GtkSignalFunc)coloursel);
	menu = createMacroMenu(window,hbox6);
	addButton(hbox6,window,"Quit",1,GTK_SIGNAL_FUNC(quit),(gpointer)window);
	parseRCFile(rcfile,&num);
	fillMacroMenu(menu,num);
	}

tag = gdk_input_add(inFile,(GdkInputCondition)GDK_INPUT_READ|GDK_INPUT_EXCEPTION,(GdkInputFunction)stdin_func,drawing_area);
if ( (input = fdopen(inFile,"r")) == NULL) exit(-2); // open it

gtk_widget_show(window);
gtk_main();

close(outFile);
return 0;
} // end main

