#define EYEDROPPER	100
#define CLS		101
#define MACROONE	1000 // if > 1000 then macro ref = type-1000, type POINT
#define MACROTWO	2000 // if > 2000 the ref = type-200, type LINE/RECT?

#define RCFILE ".drawtoolrc"

#define POINT		0
#define LINE		1
#define EMPTYRECT	2
#define FILLRECT	3
#define EMPTCIRCLE	4
#define FILLCIRCLE	5
#define EMPTELLIPSE	6
#define FILLELLIPSE	7

#define SPACING 2
#define XSIZE 15
#define YSIZE 15
#define XNUMBER 8
#define YNUMBER 2

struct macro
{
char *pathname; // path of program
char *name;	// name to appear on menus
int type;	// POINT/LINE/RECTANGLE (changes what's drawn as drag)
};
typedef struct macro macro;

char *cleanUpString(char *str);
int parseRCString(char *str,char *name,int *type,char *pathname);
int parseRCFile(char *filename,int *macronum);
void fillMacroMenu(GtkWidget *menu,int num);


#define MACRODIR "/home/agam/src/drawtool/utils/point/"

GtkWidget *createDrawWindow(int xsize,int ysize,int xoff,int yoff);
GtkWidget *createDrawArea(GtkWidget *window,GtkWidget *vbox,int xsize,int ysize);
GtkWidget *createVBox(GtkWidget *window);
GtkWidget *createHBox(GtkWidget *window);
GtkWidget *createQuitButton(GtkWidget *vbox,GtkWidget *window);
GtkWidget *addButton(GtkWidget *vbox,GtkWidget *window,char *label,int show,GtkSignalFunc func,gpointer data);

void draw_rect(GtkWidget *widget,int perm, int fill, gdouble x1, gdouble y1, gdouble x2, gdouble y2, GdkColor *colour);
void draw_line(GtkWidget *widget,int perm, gdouble x1, gdouble y1, gdouble x2, gdouble y2, GdkColor *colour);
void draw_point(GtkWidget *widget,int perm, gdouble x, gdouble y, GdkColor *colour);
void draw_circle(GtkWidget *widget,int perm, int fill, gdouble x, gdouble y, gdouble r, GdkColor *colour);
void draw_ellipse(GtkWidget *widget,int perm, int fill, gdouble x1, gdouble y1, gdouble x2, gdouble y2, GdkColor *colour);


int parse(char *str,int *type,int *x1,int *y1,int *x2,int *y2,int *r,int *g,int *b);
gint stdin_func (GtkWidget *widget, gint src, GdkInputCondition cond);

char *cmdline(int argc,char *argv[],int *xsize,int *ysize,int *xoff,int *yoff,int *show,int *inFilename,int *outFilename,int *dieOnEOF);
int min(int a,int b); // TURN ME INTO A MACRO!!!
int max(int a,int b); // TURN ME INTO A MACRO!!!
void handle_buttons(GtkWidget *w,gpointer d);

gint expose_event (GtkWidget *widget, GdkEventExpose *event);
gint configure_event (GtkWidget *widget, GdkEventConfigure *event);
gint button_press_event(GtkWidget *widget, GdkEventButton *event);
gint button_release_event(GtkWidget *widget, GdkEventButton *event);
gint motion_notify_event (GtkWidget *widget, GdkEventMotion *event);

void coloursel(GtkWidget *w, gpointer d);
void colour_changed_cb(GtkWidget *widget,GtkColorSelection *sel);
void close_colourdlg(void);
void colour_changed_cb(GtkWidget *widget,GtkColorSelection *sel);

void quit(GtkWidget *w);

void createEasyColourWindow(GtkWidget *w,gpointer d);
void closeEasyColour(void);

gint click_in_simple(GtkWidget *widget,GdkEventButton *event);
gint draw_simple(GtkWidget *widget,GdkEventExpose *event);

GtkWidget *addDrawBox(GtkWidget *box,GtkWidget *window,int xsize, int ysize,GtkSignalFunc draw_func,GtkSignalFunc click_func);
gint draw_indicator(GtkWidget *widget,GdkEventExpose *event);

void refreshPixmap(GtkWidget *widget);

gulong gdk_get_point(GtkWidget *widget,gint x,gint y);
gulong pixmapGetPoint(GtkWidget *widget,gint x,gint y);
void killPixmapImage(void);
void cls(GtkWidget *w,gpointer d);

GtkWidget *createMacroMenu(GtkWidget *window,GtkWidget *box);
void addMacroMenuItem(GtkWidget *menu,char *name,int ref,GtkSignalFunc func);
void handleMenu(int ref);
void directoryToMenu(GtkWidget *menu,char *dirname);

void doCommand(GtkWidget *widget,int type,int x1,int y1,int x2,int y2,int r,int g,int b);
gint pipe_func(GtkWidget *widget, gint src, GdkInputCondition cond);

void runMacro(int ref,int x1,int y1,int x2,int y2,int r,int g,int b);

