#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include "drawtool.h"

GdkPixmap *pixmap=NULL;
extern int throughput;
extern FILE *output,*input;
gdouble xStore;
gdouble yStore;
GdkColor curColour={0,0,0};
extern int tag;
extern int mytag;
int currentType = POINT;
extern GtkWidget *indicator;
extern int dieOnEOF;
FILE *file;

void quit(GtkWidget *w)
{
gtk_widget_hide(w);
gtk_exit(0);
} // end prog


// Create a new backing pixmap of the appropriate size
gint configure_event (GtkWidget *widget, GdkEventConfigure *event)
{
pixmap = gdk_pixmap_new(widget->window,widget->allocation.width,widget->allocation.height,-1);
gdk_draw_rectangle(pixmap,widget->style->white_gc,TRUE,0,0,widget->allocation.width,widget->allocation.height);
return TRUE;
}

// Redraw the screen from the backing pixmap
gint expose_event (GtkWidget *widget, GdkEventExpose *event)
{
gdk_draw_pixmap(widget->window,
		widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		pixmap,
		event->area.x, event->area.y,
		event->area.x, event->area.y,
		event->area.width, event->area.height);

return FALSE;
}

gint button_press_event(GtkWidget *widget, GdkEventButton *event)
{
unsigned char *colours;

if (event->button == 1 && pixmap != NULL)
	{
	if (currentType >= 1000 && currentType <2000 )
		{
		runMacro(currentType%1000,event->x,event->y,-1,-1,curColour.red,curColour.green,curColour.blue);
		}
	
	switch(currentType)
		{
		case EYEDROPPER:
		curColour.pixel = pixmapGetPoint(widget,event->x,event->y);
		draw_indicator(indicator,NULL);
		
		/* OK, I admit it, you got me. This is total trial and error,
		I know it's something like this, but this sorta works, so it's
		staying. Come to mention it, I bet that most of this stuff
		only works on 24bpp displays */
		colours = (unsigned char *) (&(curColour.pixel));
		curColour.red = ((unsigned long)(colours[2])) * 256;
		curColour.green = ((unsigned long)(colours[1])) * 256 ;
		curColour.blue = ((unsigned long)(colours[0])) * 256 ;
		
		fflush(stdout);
		break;
		
		case POINT: // if a point, just do it
		draw_point(widget,1,event->x,event->y,&curColour);
		if (throughput==0)
    			{
  			fprintf(output,"%d,%d,%d,%d,%d,%d\n",POINT,(int)event->x,(int)event->y,(int)curColour.red,(int)curColour.green,(int)curColour.blue);
  			fflush(output);
  			}
		//break; // store it anyway.... for a laugh
		
		default: // else, store click and carry on
		xStore = event->x;
		yStore = event->y;
		break;
		} // end switch
	}
return TRUE;
} // end button pressed


gint button_release_event(GtkWidget *widget, GdkEventButton *event)
{
gdouble radius=0;
if (event->button == 1 && pixmap != NULL)
	{
	if (currentType >= 2000 )
		{
		runMacro(currentType%1000,xStore,yStore,event->x,event->y,curColour.red,curColour.green,curColour.blue);
		}
		
	switch(currentType)
		{
		case POINT:
		// do nothing, cos everything happens in click + drags
		break;
		
		default:
		switch(currentType)
			{
			case LINE:
			draw_line(widget,1, xStore, yStore, event->x, event->y, &curColour);
			break;
			case EMPTYRECT:
			draw_rect(widget,1, 0, xStore, yStore, event->x, event->y, &curColour);
			break;
			case FILLRECT:
			draw_rect(widget,1, 1, xStore, yStore, event->x, event->y, &curColour);
			break;
			case EMPTELLIPSE:
			draw_ellipse(widget,1, 0, xStore, yStore, event->x, event->y, &curColour);
			break;
			case FILLELLIPSE:
			draw_ellipse(widget,1, 1, xStore, yStore, event->x, event->y, &curColour);
			break;
			case EMPTCIRCLE:
			radius = sqrt(((xStore-event->x)*(xStore-event->x)) + ((yStore-event->y)*(yStore-event->y)));
			draw_circle(widget,1,0,xStore,yStore,radius,&curColour);
			break;
			case FILLCIRCLE:
			radius = sqrt(((xStore-event->x)*(xStore-event->x)) + ((yStore-event->y)*(yStore-event->y)));		
			draw_circle(widget,1,1,xStore,yStore,radius,&curColour);
			break;
			}
		if (throughput==0)
    			{
  			if (currentType<EYEDROPPER)
  			{
  			if (currentType!=EMPTCIRCLE && currentType!=FILLCIRCLE)
  				{
  				fprintf(output,"%d,%d,%d,%d,%d,%d,%d,%d\n",currentType,(int)xStore,(int)yStore,(int)event->x,(int)event->y,(int)curColour.red,(int)curColour.green,(int)curColour.blue);
  				fflush(output);
  				} // if not circle
  			else
  				{
  				fprintf(output,"%d,%d,%d,%d,%d,%d,%d\n",currentType,(int)xStore,(int)yStore,(int)radius,(int)curColour.red,(int)curColour.green,(int)curColour.blue);
  				fflush(output);
  				} // if circle type
  			}
  			} // end < eyedropper
		break;
		} // end switch
  	}
refreshPixmap(widget);
return TRUE;
} // end button pressed


gint motion_notify_event (GtkWidget *widget, GdkEventMotion *event)
{
gint x,y;
GdkModifierType state;
gdouble radius;

if (event->is_hint)
gdk_window_get_pointer (event->window, &x, &y, &state);
else
	{
	x = event->x;
	y = event->y;
	state = event->state;
	}
if (state & GDK_BUTTON1_MASK && pixmap != NULL)
	{
	if (currentType >= 1000 && currentType <2000 )
		{
		runMacro(currentType%1000,event->x,event->y,-1,-1,curColour.red,curColour.green,curColour.blue);
		}
	else
	if (currentType >= 2000)
		{
		//runMacro(currentType-2000,event->x,event->y,xStore,yStore,curColour.red,curColour.green,curColour.blue);
		refreshPixmap(widget);
		draw_rect(widget,0,0,xStore,yStore,x,y,&curColour);
		}
	else
	switch(currentType)
		{
		case EYEDROPPER:
		curColour.pixel = pixmapGetPoint(widget,event->x,event->y);
		draw_indicator(indicator,NULL);
		break;
		case POINT:
		draw_point(widget,1, x, y, &curColour);
		if (throughput==0)
			{
			fprintf(output,"%d,%d,%d,%d,%d,%d\n",POINT,(int)x,(int)y,(int)curColour.red,(int)curColour.green,(int)curColour.blue);
			fflush(output);
			}
		break;
		default: // cls and draw
		refreshPixmap(widget);
				
		switch(currentType)
			{
			case EMPTYRECT:
			draw_rect(widget,0,0,xStore,yStore,x,y,&curColour);	
			break;
			case FILLRECT:
			draw_rect(widget,0,1,xStore,yStore,x,y,&curColour);	
			break;
			case EMPTELLIPSE:
			draw_ellipse(widget,0,0,xStore,yStore,x,y,&curColour);	
			break;
			case FILLELLIPSE:
			draw_ellipse(widget,0,1,xStore,yStore,x,y,&curColour);	
			break;
			case LINE:
			draw_line(widget,0,xStore,yStore,x,y,&curColour);
			break;
			case EMPTCIRCLE:
			radius = sqrt(((xStore-event->x)*(xStore-event->x)) + ((yStore-event->y)*(yStore-event->y)));
			draw_circle(widget,0,0,xStore,yStore,radius,&curColour);
			break;
			case FILLCIRCLE:
			radius = sqrt(((xStore-event->x)*(xStore-event->x)) + ((yStore-event->y)*(yStore-event->y)));		
			draw_circle(widget,0,1,xStore,yStore,radius,&curColour);
			break;
			}
		break;		
		} // end switch type
	}
return TRUE;
} // end mouse drag


gint stdin_func(GtkWidget *widget, gint src, GdkInputCondition cond)
{
char *str=NULL;
unsigned int type,x1,y1,x2,y2,r=0,g=0,b=0;
char *v = NULL;

setvbuf(input,NULL,_IONBF,0); // Real men take it unbuffered

if ( (str=malloc(255))==NULL ) exit(-1);
v = fgets(str,255,input);

if (feof(input)) // supplying program is done
	{
	gtk_input_remove(tag);
	fclose(input);
	if (dieOnEOF) quit(widget);
	}

if (v!=NULL)
	{
	str[strlen(str)-1] = '\0'; // cut off '\n'
	if (parse(str,&type,&x1,&y1,&x2,&y2,&r,&g,&b))
		{
		doCommand(widget,type,x1,y1,x2,y2,r,g,b);
		killPixmapImage(); // drawn something new, so update image	
		} // end parse
	} // end if v!=NULL
free(str);
return 1;
} // end what to do on stdin


void doCommand(GtkWidget *widget,int type,int x1,int y1,int x2,int y2,int r,int g,int b)
{
GdkColor colour;
GdkColormap *colourmap;

colour.red = r;
colour.green = g;
colour.blue = b;
colourmap = gdk_window_get_colormap(widget->window);
gdk_color_alloc(colourmap,&colour);
	
switch(type)
	{
	case POINT:
	draw_point(widget,1,x1,y1,&colour);
	break;	
	case LINE:
	draw_line(widget,1,x1,y1,x2,y2,&colour);
	break;
	case EMPTYRECT:
	draw_rect(widget,1,0,x1,y1,x2,y2,&colour);
	break;
	case FILLRECT:
	draw_rect(widget,1,1,x1,y1,x2,y2,&colour);
	break;
	case EMPTELLIPSE:
	draw_ellipse(widget,1,0,x1,y1,x2,y2,&colour);
	break;
	case FILLELLIPSE:
	draw_ellipse(widget,1,1,x1,y1,x2,y2,&colour);
	break;
	case EMPTCIRCLE:
	draw_circle(widget,1,0,x1,y1,x2,&colour);
	break;
	case FILLCIRCLE:
	draw_circle(widget,1,1,x1,y1,x2,&colour);
	break;
} // end switch
} // end do command