#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include "drawtool.h"

extern int tag;
extern GtkWidget *darea;
static int mytag=-1;
static FILE *macrofp;
extern int throughput;
extern macro **macros;
extern int currentType;
static int running=0;


void fillMacroMenu(GtkWidget *menu,int num)
{
int i;
for (i=0;i<num;i++)
	{	
	addMacroMenuItem(menu,macros[i]->name,i,GTK_SIGNAL_FUNC(handleMenu));
	} // end for i
} // end fill out the menu


GtkWidget *createMacroMenu(GtkWidget *window,GtkWidget *box)
{
GtkWidget *menu,*root_menu,*menu_bar;

menu = gtk_menu_new();
root_menu = gtk_menu_item_new_with_label("Macros");
gtk_menu_item_set_submenu(GTK_MENU_ITEM(root_menu),menu);
gtk_widget_show(root_menu);
menu_bar = gtk_menu_bar_new();
gtk_box_pack_start(GTK_BOX(box),menu_bar,FALSE,FALSE,0);
gtk_widget_show(menu_bar);
gtk_menu_bar_append(GTK_MENU_BAR(menu_bar),root_menu);

return menu;
} // end get main menu

void addMacroMenuItem(GtkWidget *menu,char *name,int ref,GtkSignalFunc func)
{
GtkWidget *menu_item;

menu_item = gtk_menu_item_new_with_label(name);
gtk_menu_append(GTK_MENU(menu),menu_item);
gtk_widget_show(menu_item);
gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",GTK_SIGNAL_FUNC(func),(gpointer)ref);
} // end add to macro menu


void runMacro(int ref,int x1,int y1,int x2,int y2,int r,int g,int b)
{
char *n;
int fd;
struct stat st;
char *s;
int x2n=x2,y2n=y2;

if (!running) // if no macro already running
{
if ((s = malloc(255)) == NULL) exit(-1);
n = g_strdup(macros[ref]->pathname);
if (macros[ref]->type < 3)
	{
	if (x2==-1) x2n=65535; // this is evil, just makes sure that if x1,y1 = -1,-1
	if (y2==-1) y2n=65535; // then it is x2,y2 not x1,y1 for type 1 macros
	sprintf(s,"%s %d %d %d %d %d %d %d",n,min(x1,x2n),min(y1,y2n),max(x1,x2n),max(y1,y2n),r,g,b); // send x and y args to it
	}
else
	{ // for type 3, don't be nice, good for lines.
	sprintf(s,"%s %d %d %d %d %d %d %d",n,x1,y1,x2,y2,r,g,b); // send x and y args to it
	}
if (lstat(n,&st) <0 )
	{
	fprintf(stderr,"\nbad file %s\n\n",n);
	exit(-4);
	}
if ( !(st.st_mode & S_IEXEC ) )
	{
	fprintf(stderr,"\n%s not executable file\n\n",n);
	}
else
if (mytag != -1)
	{
	//fprintf(stderr,"\nAnother macro is running\n\n");
	//this gets on my nerves, but could be handy, maybe an option is in order
	running=1;
	}
else
	{ // it's good, run it...
	macrofp = popen(s,"r");
	fd = fileno(macrofp);
	mytag = gdk_input_add(fd,(GdkInputCondition)GDK_INPUT_READ|GDK_INPUT_EXCEPTION,(GdkInputFunction)pipe_func,darea);	
	}
free(n);
} // end not one already running
} // end handle menu



void handleMenu(int ref)
{
currentType = (macros[ref]->type)*MACROONE + ref;
//runMacro(ref);
} // end handle menu


gint pipe_func(GtkWidget *widget, gint src, GdkInputCondition cond)
{
char *str=NULL;
unsigned int type,x1,y1,x2,y2,r=0,g=0,b=0;
char *v = NULL;
int t;

setvbuf(macrofp,NULL,_IONBF,0); // Real men take it unbuffered

if ( (str=malloc(255))==NULL ) exit(-1);
v = fgets(str,255,macrofp);

if (feof(macrofp)) // supplying program is done
	{
	gtk_input_remove(mytag);
	mytag = -1;
	running=0; // no longer running
	fclose(macrofp);
	}

if (v!=NULL)
	{
	str[strlen(str)-1] = '\0'; // cut off '\n'
	if (parse(str,&type,&x1,&y1,&x2,&y2,&r,&g,&b))
		{
		t = throughput; // output results of macro
		throughput = 1;		
		doCommand(widget,type,x1,y1,x2,y2,r,g,b);
		throughput = t;
		killPixmapImage(); // drawn something new, so update image	
		} // end parse
	} // end if v!=NULL
free(str);
return 1;
} // end what to do on stdin
