#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "drawtool.h"

extern GdkPixmap *pixmap;
GdkImage *image=NULL;
extern FILE *output;
extern int throughput;
extern int currentType;


void fillArea(GtkWidget *w,int x,int y,gulong fill,gulong boundary);
void gdk_put_point(GtkWidget *widget,gint x,gint y,gulong c);


void draw_point(GtkWidget *widget,int perm, gdouble x, gdouble y, GdkColor *colour)
{
GdkRectangle update_rect;
GdkGC *gc;

update_rect.x = x;update_rect.y = y;
update_rect.width = 0;update_rect.height = 0;

gc = gdk_gc_new(widget->window);
gdk_gc_set_foreground(gc,colour);

gdk_draw_point(widget->window,gc,x,y);
if (perm) gdk_draw_point(pixmap,gc,x,y);

if (throughput) 
	{
	fprintf(output,"%d,%d,%d,%d,%d,%d\n",POINT,(int)x,(int)y,(int)(colour->red),(int)(colour->green),(int)(colour->blue));
    	fflush(output);
	}

gdk_gc_destroy(gc);
} // end draw point


void draw_circle(GtkWidget *widget,int perm, int fill, gdouble x, gdouble y, gdouble r, GdkColor *colour)
{
GdkGC *gc;

gc = gdk_gc_new(widget->window);
gdk_gc_set_foreground(gc,colour);

gdk_draw_arc(widget->window,gc,fill,x-r,y-r,r*2,r*2,0,360*64);
if (perm) gdk_draw_arc(pixmap,gc,fill,x-r,y-r,r*2,r*2,0,360*64);

if (throughput)
	{
	fprintf(output,"%d,%d,%d,%d,%d,%d,%d\n",EMPTCIRCLE+fill,(int)x,(int)y,(int)r,(int)(colour->red),(int)(colour->green),(int)(colour->blue));
	fflush(output);
	}
gdk_gc_destroy(gc);
} // end draw circle


void draw_line(GtkWidget *widget,int perm, gdouble x1, gdouble y1, gdouble x2, gdouble y2, GdkColor *colour)
{
GdkRectangle up;
GdkGC *gc;

up.x = min(x1,x2);
up.y = min(y1,y2);
up.width = max(x1,x2)-up.x;
up.height = max(y1,y2)-up.y;

gc = gdk_gc_new(widget->window);
gdk_gc_set_foreground(gc,colour);

gdk_draw_line(widget->window,gc,x1,y1,x2,y2);
if (perm) gdk_draw_line(pixmap,gc,x1,y1,x2,y2);
	
if (throughput) 
	{
	fprintf(output,"%d,%d,%d,%d,%d,%d,%d,%d\n",LINE,(int)x1,(int)y1,(int)x2,(int)y2,(int)(colour->red),(int)(colour->green),(int)(colour->blue));
    	fflush(output);
	}
gdk_gc_destroy(gc);
} // end draw line


void draw_rect(GtkWidget *widget,int perm, int fill, gdouble x1, gdouble y1, gdouble x2, gdouble y2, GdkColor *colour)
{
GdkRectangle up;
GdkGC *gc;

up.x = min(x1,x2);
up.y = min(y1,y2);
up.width = max(x1,x2)-up.x;
up.height = max(y1,y2)-up.y;

gc = gdk_gc_new(widget->window);
gdk_gc_set_foreground(gc,colour);

gdk_draw_rectangle(widget->window,gc,fill,up.x,up.y,up.width,up.height);
if (perm) gdk_draw_rectangle(pixmap,gc,fill,up.x,up.y,up.width,up.height);

if (throughput) 
	{
	fprintf(output,"%d,%d,%d,%d,%d,%d,%d,%d\n",EMPTYRECT+fill,(int)x1,(int)y1,(int)x2,(int)y2,(int)(colour->red),(int)(colour->green),(int)(colour->blue));
    	fflush(output);
	}
gdk_gc_destroy(gc);
} // end draw rect


void draw_ellipse(GtkWidget *widget,int perm, int fill, gdouble x1, gdouble y1, gdouble x2, gdouble y2, GdkColor *colour)
{
GdkRectangle up;
GdkGC *gc;

up.x = min(x1,x2);
up.y = min(y1,y2);
up.width = max(x1,x2)-up.x;
up.height = max(y1,y2)-up.y;

gc = gdk_gc_new(widget->window);
gdk_gc_set_foreground(gc,colour);

gdk_draw_arc(widget->window,gc,fill,up.x,up.y,up.width,up.height,0,360*64);
if (perm) gdk_draw_arc(pixmap,gc,fill,up.x,up.y,up.width,up.height,0,360*64);

if (throughput) 
	{
	fprintf(output,"%d,%d,%d,%d,%d,%d,%d,%d\n",EMPTELLIPSE+fill,(int)x1,(int)y1,(int)x2,(int)y2,(int)(colour->red),(int)(colour->green),(int)(colour->blue));
    	fflush(output);
	}
gdk_gc_destroy(gc);
} // end draw ell


void refreshPixmap(GtkWidget *widget)
{
gdk_draw_pixmap(widget->window,
		widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		pixmap,0,0,0,0,
		widget->allocation.width,widget->allocation.height);
} // end cls


gulong gdk_get_point(GtkWidget *widget,gint x,gint y)
{
GdkImage *myimage;
gulong c;

myimage = gdk_image_get(widget->window,widget->allocation.x,widget->allocation.y,widget->allocation.width,widget->allocation.height);
c = gdk_image_get_pixel(myimage,x,y);
gdk_image_destroy(myimage);
return c;
} // end gdk_get_point


void gdk_put_point(GtkWidget *widget,gint x,gint y,gulong c)
{
GdkImage *myimage;

myimage = gdk_image_get(widget->window,widget->allocation.x,widget->allocation.y,widget->allocation.width,widget->allocation.height);
gdk_image_put_pixel(myimage,x,y,c);
gdk_image_destroy(myimage);
} // end gdk_get_point


gulong pixmapGetPoint(GtkWidget *widget,gint x,gint y)
{
gulong c=0;


if (image==NULL)
{
image = gdk_image_get(widget->window,widget->allocation.x,widget->allocation.y,widget->allocation.width,widget->allocation.height);
}
if ( 	x>=widget->allocation.x &&
	x<=widget->allocation.x+widget->allocation.width &&
	y>=widget->allocation.y &&
	y<=widget->allocation.y+widget->allocation.height
   )	
c = gdk_image_get_pixel(image,x,y);

return c;
} // end gdk_get_point

void killPixmapImage(void)
{
if (image!=NULL)
gdk_image_destroy(image);
image = NULL;
} // free up some memory


void fillArea(GtkWidget *w,int x,int y,gulong fill,gulong boundary)
{
/* I AM INCREDIBLY SLOW, PLEASE FIXME */

gulong current;
GdkColor colour;

current = gdk_get_point(w,x,y);
colour.pixel = fill;

if ((x<0) || (x>=256)) return;
if ((y<0) || (y>=256)) return;

if ((current!=boundary) & (current!=fill))
	{
	draw_point(w,0,x,y,&colour);
	fillArea(w,x+1,y,fill,boundary);
	fillArea(w,x,y+1,fill,boundary);
	fillArea(w,x-1,y,fill,boundary);
	fillArea(w,x,y-1,fill,boundary);
	} // end if
} // end fill