#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "drawtool.h"

extern macro **macros;

int parseRCFile(char *filename,int *macronum)
{
FILE *fp;
char *v;
char *str,*name,*pathname;
int type;

*macronum = 0;

if ((str=malloc(255))==NULL) exit(-1);
if ((name=malloc(255))==NULL) exit(-1);
if ((pathname=malloc(255))==NULL) exit(-1);

fp = fopen(filename,"r");
if (fp==NULL)
	{
	fprintf(stderr,"\nCan't open rc file, %s\n\n",filename);
	exit(-1);
	}

while (!feof(fp))
	{
	v = fgets(str,255,fp);
	if (v!=NULL)
		{
		if (str[strlen(str)-1] == '\0')
		str[strlen(str)-1] = '\0'; // cut off '\n'
		
		if (parseRCString(str,name,&type,pathname))
			{
			macros[*macronum] = (macro*)malloc(sizeof(macro));
			macros[*macronum]->name = g_strdup(name);
			macros[*macronum]->pathname = g_strdup(pathname);
			macros[*macronum]->type = type;
			(*macronum)++;
			fflush(stdout);
			}
		} // str is a string of the file
	} // end reading file
	
fclose(fp);
free(str);
free(name);
free(pathname);
return 1;
} // end parse rc file

int parseRCString(char *str,char *name,int *type,char *pathname)
{
char *s;

s = cleanUpString(str);
if (s[0]!='#' && s[0]!='\0') // valid command string
	{
	if (sscanf(s,"%s %s %d",name,pathname,type)<3)
		{
		fprintf(stderr,"\n-%s- is not a valid rc string\n\n",s);
		return 0;
		}
	else
		{
		return 1;
		}
	} // if valid string type
else return 0;
} // end parse a string from the rc file

char *cleanUpString(char *str)
{
// remove whitespace from start and end of string
int start;
int end;

start=0;
while( isspace(str[start]) ) start++;

end = strlen(str);
while( isspace(str[end]) ) end--;

str[end] = '\0'; // null the end
return str+start; // return start
} // end clean ends of string


