#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include "drawtool.h"

extern int showButtons;

GtkWidget *createDrawWindow(int xsize,int ysize,int xoff,int yoff)
{
GtkWidget *window;  
window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_policy((GtkWindow *)window,0,0,1);
gtk_widget_set_uposition(window,xoff,yoff);
gtk_window_set_title((GtkWindow *)window,"drawtool");
gtk_signal_connect(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC (quit), NULL);
return window;
} // end create window to draw in.


GtkWidget *createDrawArea(GtkWidget *window,GtkWidget *vbox,int xsize,int ysize)
{
GtkWidget *drawing_area;
drawing_area = gtk_drawing_area_new ();
gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), xsize, ysize);
gtk_box_pack_start (GTK_BOX (vbox), drawing_area, TRUE, TRUE, 0);
// Signals used to handle backing pixmap
gtk_signal_connect(GTK_OBJECT (drawing_area), "expose_event",
		  (GtkSignalFunc) expose_event, NULL);
gtk_signal_connect(GTK_OBJECT(drawing_area),"configure_event",
		  (GtkSignalFunc) configure_event, NULL);
// Event signals
if (showButtons)
{
gtk_signal_connect(GTK_OBJECT (drawing_area), "motion_notify_event",
		  (GtkSignalFunc) motion_notify_event, NULL);
gtk_signal_connect(GTK_OBJECT (drawing_area), "button_press_event",
		  (GtkSignalFunc) button_press_event, NULL);
gtk_signal_connect(GTK_OBJECT (drawing_area), "button_release_event",
		  (GtkSignalFunc) button_release_event, NULL);
}
gtk_widget_set_events(drawing_area, GDK_EXPOSURE_MASK
		      | GDK_LEAVE_NOTIFY_MASK
		      | GDK_BUTTON_PRESS_MASK
		      | GDK_BUTTON_RELEASE_MASK
		      | GDK_POINTER_MOTION_MASK
		      | GDK_POINTER_MOTION_HINT_MASK);
gtk_widget_show(drawing_area);
return drawing_area;
} // end create drawing area to draw in.


GtkWidget *createVBox(GtkWidget *window)
{
GtkWidget *vbox;
vbox = gtk_vbox_new(FALSE, 2);
gtk_container_add(GTK_CONTAINER(window),vbox);
gtk_widget_show(vbox);
return vbox;
} // end create vbox for packing


GtkWidget *createHBox(GtkWidget *window)
{
GtkWidget *hbox;
hbox = gtk_hbox_new(FALSE, 2);
gtk_container_add(GTK_CONTAINER(window),hbox);
gtk_widget_show(hbox);
return hbox;
} // end create hbox for packing
